{*************************************************************************}
{ GH Freebrary                                                            }
{                                                                         }
{ GHFDataSetProvider_Reg.pas - TghDataSetProvider class registration      }
{                              unit.                                      }
{                                                                         }
{ This software is distributed under the open source BSD license.         }
{                                                                         }
{ Copyright (c) 2002-2013, Al Gonzalez (rescatandoadelphi.blogspot.com)   }
{ All rights reserved.                                                    }
{                                                                         }
{ Redistribution and use in source and binary forms, with or without      }
{ modification, are permitted provided that the following conditions are  }
{ met:                                                                    }
{                                                                         }
{   - Redistributions of source code must retain the above copyright      }
{     notice, this list of conditions and the following disclaimer.       }
{   - Redistributions in binary form must reproduce the above copyright   }
{     notice, this list of conditions and the following disclaimer in the }
{     documentation and/or other materials provided with the              }
{     distribution.                                                       }
{   - Neither the name of Al Gonzalez nor the names of his contributors   }
{     may be used to endorse or promote products derived from this        }
{     software without specific prior written permission.                 }
{                                                                         }
{ THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS }
{ IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED   }
{ TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A         }
{ PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT      }
{ HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,  }
{ SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT        }
{ LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,   }
{ DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY   }
{ THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     }
{ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   }
{ OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    }
{*************************************************************************}

{ Please contribute to improve this library.  I am not a good programmer,
  but good programmers know what Delphi is worth.

  A.G. }

Unit GHFDataSetProvider_Reg;  { Data Set Provider Registration }

Interface

  Uses
    GHF_Reg, DesignEditors;

  Type
    { TghDataSetProvider Editor class }
    TghDataSetProviderEditor = Class (TDefaultEditor)
      Public
        { Overridden methods }
        Procedure Edit; Override;
        Procedure ExecuteVerb (Index :Integer); Override;
        Function GetVerb (Index :Integer) :String; Override;
        Function GetVerbCount :Integer; Override;
    End;

  { Functions and procedures }

  Procedure Register;

Implementation

  Uses
    DSDesign, GHFDataSetProvider, GHFInnerDataSetDesigner, DsnDBCst,
    Classes, DesignIntf;

  { TghDataSetProviderEditor }

  { Public overridden methods }

  Procedure TghDataSetProviderEditor.Edit;
  Begin
    If GetVerbCount () > 0 Then
      ExecuteVerb (0)
    Else
      Inherited Edit;
  End;
  
  Procedure TghDataSetProviderEditor.ExecuteVerb (Index :Integer);
  Begin
    If Index = 0 Then
      ShowFieldsEditor (Designer, TghDataSetProvider (
        Component).DataSet, TghInnerDataSetDesigner);
  End;

  Function TghDataSetProviderEditor.GetVerb (Index :Integer) :String;
  Begin
    If Index = 0 Then
      Result := SDatasetDesigner;
  End;

  Function TghDataSetProviderEditor.GetVerbCount :Integer;
  Begin
    Result := Byte (
      TghDataSetProvider (Component).InnerDataSetClass <> '');
  End;

  { Functions and procedures }

  Procedure Register;
  Begin
    RegisterComponents ('GH Freebrary', [TghDataSetProvider]);
    RegisterComponentEditor (TghDataSetProvider, TghDataSetProviderEditor);
  End;

End.

